config/routes.rb
Rails.application.routes.draw do
	mount ActionCable.server => '/cable'
  root 'service_providers#index'
  resources :service_providers
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/service_provider.rb
class ServiceProvider < ApplicationRecord
	#image uploader
	mount_uploader :image, AttachmentUploader
	# self.per_page = 4
  
  #validations
  validates :name ,presence: {message: "Service Provider name is required."}
  validates :name, allow_blank: true, format: {:with => /\A[^`!@#\$%\^*+_=]+\z/, message: "Invalid ISP Name."}
  validates :image, presence: { message: "Service Provider brand image is required." }
  validates :image, allow_blank: true, format: { with: %r{.(jpeg|jpg|bmp|png)\Z}i, message: 'Service Provider brand image must be .jpeg, .jpg , .png or .bmp image' }
	validates :url, url: { allow_blank: true, message: "Please enter valid portal URL" }

	def self.search(params)
		service_providers = ServiceProvider.all
		if params[:search_text].present? and params[:name_or_price_button].present?
			ids1 = service_providers.where('name ILIKE ?', '%' + params[:search_text] + '%').pluck(:id)
			ids2 = service_providers.where('lowest_price = ?', params[:search_text]).pluck(:id) rescue []
			ids = ids1 << ids2
			service_providers = service_providers.where('id IN (?)', ids.flatten)
		end
		service_providers = service_providers.order("rating #{params[:order]}") if params[:sort_by] == "rating" and params[:sort_button].present?
		service_providers = service_providers.order("lowest_price #{params[:order]}") if params[:sort_by] == 'price' and params[:sort_button].present?
		service_providers	
	end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/service_providers_controller.rb
class ServiceProvidersController < ApplicationController
  before_action :authenticate_user!, only: [:new, :create, :edit, :update]
  before_action :set_service_provider, only: [:show, :edit, :update, :destroy]

  # GET /service_providers
  # GET /service_providers.json
  def index
    @service_providers = ServiceProvider.search(params).paginate(page: params[:page], per_page: 4)
    respond_to do |format|
      format.html
      format.js
    end
  end

  # GET /service_providers/1
  # GET /service_providers/1.json
  def show
  end

  # GET /service_providers/new
  def new
    @service_provider = ServiceProvider.new
  end

  # GET /service_providers/1/edit
  def edit
  end

  # POST /service_providers
  # POST /service_providers.json
  def create
    @service_provider = ServiceProvider.new(service_provider_params)
    respond_to do |format|
      if @service_provider.save
        format.html { redirect_to @service_provider, notice: 'Service provider was successfully created.' }
        format.json { render :show, status: :created, location: @service_provider }
      else
        format.html { render :new }
        format.json { render json: @service_provider.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /service_providers/1
  # PATCH/PUT /service_providers/1.json
  def update
    respond_to do |format|
      if @service_provider.update(service_provider_params)
        ActionCable.server.broadcast 'service_provider_channel',
          name: @service_provider.name,
          lowest_price: @service_provider.lowest_price,
          rating: @service_provider.rating,
          max_speed: @service_provider.max_speed,
          contact_no: @service_provider.contact_no,
          email: @service_provider.email,
          url: @service_provider.url
        format.html { redirect_to @service_provider, notice: 'Service provider was successfully updated.' }
        format.json { render :show, status: :ok, location: @service_provider }
      else
        format.html { render :edit }
        format.json { render json: @service_provider.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /service_providers/1
  # DELETE /service_providers/1.json
  def destroy
    @service_provider.destroy
    respond_to do |format|
      format.html { redirect_to service_providers_url, notice: 'Service provider was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_service_provider
      @service_provider = ServiceProvider.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def service_provider_params
      params.require(:service_provider).permit(:name, :lowest_price, :rating, :max_speed, :description, :contact_no, :email, :image, :url)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/service_providers_helper.rb
module ServiceProvidersHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>IspProvider</title>
    <%= action_cable_meta_tag %>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>

    <%= stylesheet_link_tag    'application', media: 'all' %>
    <%= javascript_include_tag 'application' %>
  </head>

  <body>
    <nav class="navbar navbar-expand-sm bg-light">
      <ul class="navbar-nav">
        <% if user_signed_in? %>
          <li class="nav-item">
            <a class="nav-link" href="#">Welcome, <%= current_user.email %></a>
          </li>
          <li class="nav-item">
            <%= link_to "Sign out", destroy_user_session_path, :method => :delete, :class => 'nav-link btn btn-primary btn-sm' %>
          </li>
        <% else %>
          <%= link_to "Sign In", new_user_session_path, :class => 'nav-link btn btn-primary btn-sm' %>  
        <% end %>
      </ul>
    </nav>
    <div class="container margin-top-20px">
      <%= yield %>
    </div>
  </body>
</html>

app/views/service_providers/_form.html.erb
<% if service_provider.errors.any? %>
  <%= render :partial => '/shared/errors_listing', locals: {objekt: service_provider} %>
<% end %>
<div class="row"/>
  <div class="col-md-6 offset-md-3">
    <%= form_with(model: service_provider, local: true) do |form| %>
      <div class="form-group">
        <label>Name:</label>
        <%= form.text_field :name, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>Email:</label>
        <%= form.email_field :email, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>Description:</label>
        <%= form.text_area :Description, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>Lowest Price:</label>
        <%= form.number_field :lowest_price, :class => 'form-control', :step => 'any' %>
      </div>
      <div class="form-group">
        <label>Max Speed:</label>
        <%= form.text_field :max_speed, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>Contact No:</label>
        <%= form.text_field :contact_no, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>URL:</label>
        <%= form.text_field :url, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <label>Image:</label>
        <%= form.file_field :image, :class => 'form-control' %>
      </div>
      <div class="form-group">
        <div id = "rating-form"> <label> Rating</label> </div>
      </div>
      <div class="form-group margin-bottom-50px">
        <%= link_to "Cancel", service_providers_path, :class => 'btn btn-info' %>
        <%= form.submit 'Submit', :class => "btn btn-primary"  %>
      </div>  
    <% end %>
  </div>
</div>

app/views/service_providers/_service_provider.html.erb
<div class="row margin-top-20px">
      <div class="col-12 mt-3">
          <div class="card">
              <div class="card-horizontal">
                  <div class="img-square-wrapper">
                      <img class="provider-image" src="<%= service_provider.image.url %>" alt="<%= service_provider.name %>">
                  </div>
                  <div class="card-body">
                    <div class="row">
                    <div class="col-md-8">
                      <div class="review-rating" data-score = "<%= service_provider.rating %>"></div>
                      <h4 class="card-title margin-top-10px"><%= service_provider.name %></h4>
                      <p class="card-text"><%= service_provider.description.truncate(300) rescue nil %></p>
                      <%= link_to "View Details", service_provider_path(service_provider), :class => "btn btn-info btn-sm" %>
                    </div>
                    <div class="col-md-4">
                      <h5 class="card-price text-center"><i class="fa fa-wifi font-20px" ></i><span class="term"><%= service_provider.max_speed %></span></h5>
                      <h6 class="card-price text-center"><i class="fa fa-rupee font-20px" ></i> <span class="term"><%= service_provider.lowest_price %></span></h6>
                    </div>
                    </div>
                  </div>
              </div>
              <div class="card-footer">
                <small class="text-muted provider-url"><%= service_provider.contact_no %></small> | 
                <small class="text-muted provider-url"><%= service_provider.email %></small> | 
                <small class="text-muted provider-url"><%= link_to service_provider.url, service_provider.url, target: '_blank' %></small>
                <% if user_signed_in? %>
                  <div class="pull-right">
                    <%= link_to '<i class="fa fa-pencil"></i>'.html_safe, edit_service_provider_path(service_provider), title: 'Edit Details' %> | <%= link_to '<i class="fa fa-trash color-red"></i>'.html_safe, service_provider_path(service_provider), title: 'Delete Service Provider',  method: :delete, data: { confirm: 'Are you sure, you want to delete this service provider?' } %>
                  </div>
                <% end %>
              </div>
          </div>
      </div>
    </div>

app/views/service_providers/edit.html.erb
<div class="row">
	<div class="col-md-6 offset-md-3">
		<h1>Edit Service Provider</h1>
	</div>
</div>

<%= render 'form', service_provider: @service_provider %>

app/views/service_providers/index.html.erb
<div class="row">
  <div class="<%= user_signed_in? ? 'col-md-10' : 'col-md-12' %>">
    <%= render 'shared/search_form' %>
  </div>
  <% if user_signed_in? %>
    <div class="col-md-2">
      <%= link_to 'Add New ISP', new_service_provider_path(), :class => 'btn btn-info btn-sm' %>
    </div>
  <% end %>
</div>

<div id="providers-listing" class="margin-bottom-50px">
  <%= render 'shared/listing'  %>  
</div>

<div class="row">
	<div class="col-md-12">
		<%= will_paginate @service_providers, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
	</div>
</div>

app/views/service_providers/index.js.erb
$('#providers-listing').html("<%= escape_javascript render(:partial => 'shared/listing') %>");
$('.review-rating').raty({
	readOnly: true,
	score: function() {
		return $(this).attr('data-score');
	},
	path: '/assets/'
});

app/views/service_providers/new.html.erb
<div class="row">
	<div class="col-md-6 offset-md-3">
		<h1>New Service Provider</h1>
	</div>
</div>

<%= render 'form', service_provider: @service_provider %>

app/views/service_providers/show.html.erb
<div class="card">
  <div class="card-body">
    <div class="row">
      <div class="col-md-2">
        Name:
      </div>
      <div class="col-md-10 provider-name">
        <%= @service_provider.name %>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Lowest Price:
      </div>
      <div class="col-md-10 provider-lowest-price">
        <%= @service_provider.lowest_price %>
      </div>
    </div>
    <div class="row margin-top-20px ">
      <div class="col-md-2">
        Rating:
      </div>
      <div class="col-md-10">
        <div class="review-rating" data-score = "<%= @service_provider.rating %>"></div>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Max Speed:
      </div>
      <div class="col-md-10 provider-max-speed">
        <%= @service_provider.max_speed %>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Description:
      </div>
      <div class="col-md-10 provider-description">
        <%= @service_provider.description %>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Contact Number:
      </div>
      <div class="col-md-10 provider-contact-no">
        <%= @service_provider.contact_no %>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Email:
      </div>
      <div class="col-md-10 provider-email">
        <%= @service_provider.email %>
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-2">
        Image:
      </div>
      <div class="col-md-10">
        <img src="<%= @service_provider.image %>" class="provider-image">
      </div>
    </div>
    <div class="row margin-top-20px">
      <div class="col-md-12">
        <%= link_to 'Back', service_providers_path, :class => 'btn btn-primary' %>
        <% if user_signed_in? %>
          <%= link_to 'Edit', edit_service_provider_path(@service_provider), :class => 'btn btn-info' %> 
        <% end %>
      </div>
    </div>
</div>

<div id="messages">
</div>

app/views/shared/_errors_listing.html.erb
<div class="row"/>
  <div class="col-md-6 offset-md-3">
		<div id="error_explanation">
		<h4><%= pluralize(objekt.errors.count, "error") %> prohibited this <%= objekt.class.name.downcase %> from being saved:</h4>
		<div class="row">
		  <div class="col-lg-12 validation">
		    <% objekt.errors.messages.each do |error_message| %>
		      <%= error_message.first.to_s.split('_').join(' ').titleize %> : <%= error_message[1].last %> <br />
		    <% end %>    
		  </div>
		</div>
		</div>
  </div>
</div>

app/views/shared/_listing.html.erb
<% if @service_providers.present? %>
  <% @service_providers.each do |service_provider| %>
    <div class="row margin-top-20px">
      <div class="col-12 mt-3">
          <div class="card">
              <div class="card-horizontal">
                  <div class="img-square-wrapper">
                      <img class="provider-image" src="<%= service_provider.image.url %>" alt="<%= service_provider.name %>">
                  </div>
                  <div class="card-body">
                    <div class="row">
                    <div class="col-md-8">
                      <div class="review-rating" data-score = "<%= service_provider.rating %>"></div>
                      <h4 class="card-title margin-top-10px"><%= service_provider.name %></h4>
                      <p class="card-text"><%= service_provider.description.truncate(300) rescue nil %></p>
                      <%= link_to "View Details", service_provider_path(service_provider), :class => "btn btn-info btn-sm" %>
                    </div>
                    <div class="col-md-4">
                      <h5 class="card-price text-center"><i class="fa fa-wifi font-20px" ></i><span class="term"><%= service_provider.max_speed %></span></h5>
                      <h6 class="card-price text-center"><i class="fa fa-rupee font-20px" ></i> <span class="term"><%= service_provider.lowest_price %></span></h6>
                    </div>
                    </div>
                  </div>
              </div>
              <div class="card-footer">
                <small class="text-muted provider-url"><%= service_provider.contact_no %></small> | 
                <small class="text-muted provider-url"><%= service_provider.email %></small> | 
                <small class="text-muted provider-url"><%= link_to service_provider.url, service_provider.url, target: '_blank' %></small>
                <% if user_signed_in? %>
                  <div class="pull-right">
                    <%= link_to '<i class="fa fa-pencil"></i>'.html_safe, edit_service_provider_path(service_provider), title: 'Edit Details' %> | <%= link_to '<i class="fa fa-trash color-red"></i>'.html_safe, service_provider_path(service_provider), title: 'Delete Service Provider',  method: :delete, data: { confirm: 'Are you sure, you want to delete this service provider?' } %>
                  </div>
                <% end %>
              </div>
          </div>
      </div>
    </div>
  <% end %>
<% else %>
  <div class="margin-top-20px">
    <div class="alert alert-danger">
      No service providers found.
    </div>
  </div>
<% end %>

app/views/shared/_search_form.html.erb
<%= form_tag '/service_providers', method: 'get', :class => 'form-horizontal search-form', :remote => true do %>
  <div class="input-group" id="adv-search">
    <input type="text" name="search_text" class="form-control" placeholder="Search by name or price" />
    <div class="input-group-btn">
      <div class="btn-group" role="group">
        <div class="dropdown dropdown-lg">
            <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-expanded="false"><span class="caret"></span></button>
            <div class="dropdown-menu dropdown-menu-right" role="menu">
                <div class="form-group">
                  <label for="filter">Sort by</label>
                  <select name="sort_by" class="form-control">
                    <option value="price">Price</option>
                    <option value="rating">Rating</option>
                  </select>
                </div>
                <div class="form-group">
                  <label for="filter">Select Order</label>
                  <select name="order" class="form-control">
                    <option value="Asc">Low To High</option>
                    <option value="Desc">High To Low</option>
                  </select>
                </div>
                <button type="submit" name="sort_button" value="1" class="btn btn-primary"><span class="fa fa-search" aria-hidden="true"></span></button>
              <%# end %>
            </div>
        </div>
        <button type="submit" name="name_or_price_button" value="1" class="btn btn-primary"><span class="fa fa-search" aria-hidden="true"></span></button>
      </div>
    </div>
  </div>
<% end %>